Imports System.Reflection
Imports System.text

Public Class Form1

    Private Sub btnExibeAssembly_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExibeAssembly.Click

        ' ----- Dado um assembly, exiba os detalhes a partir do seu manifest.
        Dim usaAssembly As Assembly
        Dim exibirConteudo As New StringBuilder

        ' ----- carrega o assembly.
        If (My.Computer.FileSystem.FileExists(txtCaminhoAssembly.Text) = False) Then
            MsgBox("Informe um nome de assembly vlido " & "  com um caminho vlido.")
            Return
        End If

        Try
            usaAssembly = Reflection.Assembly.LoadFile(txtCaminhoAssembly.Text)
        Catch ex As System.Exception
            MsgBox("No foi possvel acessar o assembly: " & ex.Message)
            Return
        End Try

        ' ----- limpa o contedo existente
        txtAssemblyDetalhes.Clear()

        ' ----- Exibe o nome completo
        exibirConteudo.AppendLine("Nome Completo: " & usaAssembly.FullName)

        ' ----- Lista todos so recursos
        exibirConteudo.AppendLine()
        exibirConteudo.AppendLine("Resources")

        For Each umNome As String In usaAssembly.GetManifestResourceNames()
            exibirConteudo.AppendLine(" - " & umNome)
        Next umNome

        ' ----- Lista todos os tipos exportados
        exibirConteudo.AppendLine()
        exibirConteudo.AppendLine("Exported Types")

        For Each umTipo As System.Type In usaAssembly.GetExportedTypes()
            exibirConteudo.AppendLine(" - " & umTipo.Name)
        Next umTipo

        ' ----- Processa cada modulo, e cada tipo no modulo
        exibirConteudo.AppendLine()
        exibirConteudo.AppendLine("Modules")

        For Each umModulo As Reflection.Module In usaAssembly.GetLoadedModules()
            exibirConteudo.AppendLine(" - " & umModulo.Name)

            For Each umTipo As System.Type In umModulo.GetTypes()
                exibirConteudo.AppendLine(" Type: " & umTipo.Name)

                ' ----- MOstra os campos incluidos em cada tipo
                For Each umCampo As Reflection.FieldInfo In umTipo.GetFields()
                    exibirConteudo.AppendLine("        Field: " & umCampo.ToString())
                Next umCampo

                ' ----- Mostra os mtodos incluidos em cada tipo
                For Each umMtodo As Reflection.MethodInfo In umTipo.GetMethods()
                    exibirConteudo.AppendLine(" Method: " & umMtodo.ToString())
                Next umMtodo
            Next umTipo

        Next umModulo

        ' ----- mmostra o resultado
        txtAssemblyDetalhes.Text = exibirConteudo.ToString()
    End Sub
End Class
